(defproto var-list-proto '(spreadplot-supervisor showing) ()
  name-list-proto ())

(defmeth var-list-proto :links ()
  (if (member self *rsq-plots*) *rsq-plots*))

(defmeth var-list-proto :linked (&optional (link nil set))
  (when set (setf *rsq-plots* (if link (cons self *rsq-plots*)
                                  (remove self *rsq-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth var-list-proto :spreadplot-supervisor (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'spreadplot-supervisor) obj-id)) 
  (slot-value 'spreadplot-supervisor))


(defmeth var-list-proto :showing (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'showing) obj-id)) 
  (slot-value 'showing))


(defmeth var-list-proto :show-plot ()
  (send self :show-window)
  (send self :showing t))

(defmeth var-list-proto :close ()
  (send (send self :spreadplot-supervisor) :close-dialog self)
  )

(defmeth var-list-proto :isnew (ssp &rest args)
  (let* (
         (vars (select (send (send ssp :model) :variables)
                       (send (send ssp :model) :iv)))
         (nvars (length vars))
         (vl (call-next-method 0 :show nil))
         )
  (send vl :spreadplot-supervisor ssp)
  (send vl :add-points (list (iseq nvars)))
  (send vl :point-label (iseq nvars) vars)
  (send vl :title "Predictor Variables")
  (send vl :adjust-to-data)
 vl))

(defproto obs-list-proto '(spreadplot-supervisor showing) ()
  name-list-proto ())


(defmeth obs-list-proto :spreadplot-supervisor (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'spreadplot-supervisor) obj-id)) 
  (slot-value 'spreadplot-supervisor))


(defmeth obs-list-proto :showing (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'showing) obj-id)) 
  (slot-value 'showing))


(defmeth obs-list-proto :show-plot ()
  (send self :show-window)
  (send self :showing t))


(defmeth obs-list-proto :close ()
  (send (send self :spreadplot-supervisor) :close-dialog self)
  )

(defmeth obs-list-proto :isnew (ssp &rest args)
  (let* (
         (obs (send current-data :labels))
         (nobs (length obs))
         (ol (call-next-method 0 :show nil))
         )
  (send ol :spreadplot-supervisor ssp)
  (send ol :add-points (list (iseq nobs)))
  (send ol :point-label (iseq nobs) obs)
  (send ol :title "Observations")
  (send ol :adjust-to-data)
 ol))



(defmeth morals-spreadplot-supervisor-proto :choose-location (plot)

 #+macintosh 
    (let* (
         (loc-item1 (send toggle-item-proto :new "Upper Left" :location (list 10 10)))
         (loc-item2 (send toggle-item-proto :new "Upper Middle" :location (list 110 10)))
         (loc-item3 (send toggle-item-proto :new "Upper Right" :location (list 225 10)))
         (loc-item4 (send toggle-item-proto :new "Lower Left" :location (list 10 35)))
         (loc-item5 (send toggle-item-proto :new "Lower Middle" :location (list 110 35)))
         (loc-item6 (send toggle-item-proto :new "Lower Right" :location (list 225 35)))
         (cancel (send modal-button-proto :new "Cancel"
                          :action #'(lambda ()
                            (let ((dialog (send cancel :dialog)))
                              (send dialog :modal-dialog-return nil)))))
         (ok (send modal-button-proto :new "OK"
                   :action #'(lambda () 
                               (let ((dialog (send ok :dialog)))
                               (if (equalp (send loc-item1 :value) t)
                                   (send plot :location 
                                         (select loc11 0) (select loc11 1)))
                               (if (equalp (send loc-item2 :value) t)
                                   (send plot :location 
                                         (select loc12 0) (select loc12 1)))
                               (if (equalp (send loc-item3 :value) t)
                                   (send plot :location 
                                         (select loc13 0) (select loc13 1)))
                               (if (equalp (send loc-item4 :value) t)
                                   (send plot :location 
                                         (select loc21 0) (select loc21 1)))
                               (if (equalp (send loc-item5 :value) t)
                                   (send plot :location 
                                         (select loc22 0) (select loc22 1)))
                               (if (equalp (send loc-item6 :value) t)
                                   (send plot :location 
                                         (select loc23 0) (select loc23 1)))
                               (send dialog :modal-dialog-return t)))))   

         (loc-dialog (send modal-dialog-proto :new 
                      (list (list loc-item1 loc-item2 loc-item3)
                            (list loc-item4 loc-item5 loc-item6)
                            (list ok cancel)))))
        (send loc-dialog :modal-dialog))

 #-macintosh
        (let* ((loc-item (send choice-item-proto :new
                   (list "Upper Left" "Upper Middle" "Upper Right" "Lower Left" 
                         "Lower Middle" "Lower Right")))
              (cancel (send modal-button-proto :new "Cancel"
                          :action #'(lambda ()
                            (let ((dialog (send cancel :dialog)))
                              (send dialog :modal-dialog-return nil)))))
              
              (ok (send modal-button-proto :new "OK"
                   :action #'(lambda () 
                               (let ((dialog (send ok :dialog)))
                               (if (equalp (send loc-item :value) 0)
                                   (send plot :location 
                                         (select loc11 0) (select loc11 1)))
                               (if (equalp (send loc-item :value) 1)
                                   (send plot :location 
                                         (select loc12 0) (select loc12 1)))
                               (if (equalp (send loc-item :value) 2)
                                   (send plot :location 
                                         (select loc13 0) (select loc13 1)))
                               (if (equalp (send loc-item :value) 3)
                                   (send plot :location 
                                         (select loc21 0) (select loc21 1)))
                               (if (equalp (send loc-item :value) 4)
                                   (send plot :location 
                                         (select loc22 0) (select loc22 1)))
                               (if (equalp (send loc-item :value) 5)
                                   (send plot :location 
                                         (select loc23 0) (select loc23 1)))
                               (send dialog :modal-dialog-return t))))) 
              (loc-dialog (send modal-dialog-proto :new 
                      (list loc-item
                            (list ok cancel)))))
        (send loc-dialog :modal-dialog)))



(defproto LOCATION-OVERLAY-PROTO '(location spreadplot-supervisor) () graph-overlay-proto)

; slot-accessor method

(defmeth LOCATION-OVERLAY-PROTO :location (&optional (list nil set)) 
  (when set (setf (slot-value 'location) list)) 
  (slot-value 'location))


(defmeth LOCATION-OVERLAY-PROTO :spreadplot-supervisor (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'spreadplot-supervisor) obj-id)) 
  (slot-value 'spreadplot-supervisor))


; constructor function

(defun make-overlay2 (graph ssp)
  (let* ((overlay (send LOCATION-OVERLAY-PROTO :new))
         (ascent (send graph :text-ascent))
         (h (+ ascent (send graph :text-descent)))
         (x ascent)
         (y (round (* 1.5 ascent)))
         (box ascent))
  (send graph :margin 0 (round (* 1.5 h)) 0 0) 
  (send overlay :location (list x y box (round (+ x (* 1.5 box)))))
  (send overlay :spreadplot-supervisor ssp)
  overlay))
  
; object-specific methods

(defmeth LOCATION-OVERLAY-PROTO :redraw ()
  (let* ((loc (send self :location))
         (x (first loc))
         (y (second loc))
         (box (third loc))
         (string-x (fourth loc))
         (graph (send self :graph)))
    (send graph :frame-rect x (- y box) box box)
    (send graph :draw-string "Location" string-x y)))

(defmeth LOCATION-OVERLAY-PROTO :do-click (x y m1 m2) 
  (let* ((loc (send self :location))
         (box (third loc))
         (left (first loc))
         (top (- (second loc) box))
         (right (+ left box))
         (bottom (+ top box))
         (graph (send self :graph))) 
    (when (and (< left x right) (< top y bottom))
          (send (send graph :spreadplot-supervisor) :choose-location graph)
          t)))



(defun make-overlay (graph ssp)
  (let* ((overlay (send ITERATE-OVERLAY-PROTO :new))
         (ascent (send graph :text-ascent))
         (h (+ ascent (send graph :text-descent)))
         (x ascent)
         (y (+ 20 (round (* 1.5 ascent))))
         (box ascent))
  (send graph :margin 0 (round (* 1.5 h)) 0 0)
  (send overlay :location (list x y box (round (+ x (* 1.5 box)))))
  (send overlay :spreadplot-supervisor ssp)
  overlay))
  


(defmeth ITERATE-OVERLAY-PROTO :redraw ()
  (let* ((loc (send self :location))
         (x (first loc))
         (y (second loc))
         (box (third loc))
         (string-x (fourth loc))
         (graph (send self :graph)))
    (send graph :frame-rect x (- y box) box box)
    (send graph :draw-string "Iterate" string-x y)))


(defmeth morals-spreadplot-supervisor-proto :update-rsq-beta-plot () 
  (let* (
         (plot (send self :rsq-beta-plot))
         (i 0)
         (j 0)
         (k 0)
         (iter-list nil)
         (rsq-beta-list nil)
         (iteration-list nil)
         (model (send (send self :model) :morals-model))
         (count (+ (send model :count) 1))
         (rsq-list (send model :rsq-list))
         )
    (send plot :clear-points)
    (send plot :clear-lines)
    (dotimes (k count)
             (setf iteration-list (append iteration-list 
                             (list (repeat k (length (first 
                                   (send model :standardized-beta-list))))))))
    (dotimes (j (length (first (send model :standardized-beta-list)))) 
           (dotimes (i (length (send model :standardized-beta-list)))  
                    (setf rsq-beta-list (append rsq-beta-list (list 
                                  (select (select 
                                  (send model :standardized-beta-list) i) 
                                          j))))
                    (setf iter-list (append iter-list (list (select (select
                                    iteration-list i) j)))))
           (send plot :add-lines iter-list rsq-beta-list)
           (send plot :add-lines (iseq count) rsq-list)
           (setf i 0)
           (setf iter-list nil)
           (setf rsq-beta-list nil))
    (send plot :add-points (list (repeat (send model :count) 
            (length (combine (last (send model :standardized-beta-list)))))
                    (combine (last (send model :standardized-beta-list))))
            :point-labels (select (send (send self :model) :variables)
                                (send (send self :model) :iv)))
    (when (equalp (send model :count) 0)
          (send plot :add-points (list 0) (list (send model :r-squared))))
    (when (> (send model :count) 0)
          (send plot :add-points (list (send model :count)) 
                     (list (select (send model :rsq-list) 
                                   (send model :count)))
                     :point-labels (list "RSQ")))
    (send plot :adjust-to-data)
    (send self :rsq-beta-plot plot) 
    plot))


(defmeth morals-spreadplot-supervisor-proto :create-plots () 
  (let* (
         (i 0)
         (j 0)
         (k 0)
         (iteration-list nil)
         (iter-list nil)
         (rsq-beta-list nil)
         (a 0)
         (model (send (send self :model) :morals-model))
         (dv2 (select (send (send self :model) :variables) 
                     (send (send self :model) :dv)))
         (dv (if (listp dv2) (select dv2 0) dv2))
         (pred (strcat "OLS Predicted " dv))
         (count (+ (send model :count) 1))
         (rsq-list (send model :rsq-list))
         (model2 (send self :model))
         (lin-reg (send model2 :lin-reg-model))
         (datamat (send model2 :data-matrix))
         (nobs (send model2 :nobs))
         (plots nil)
         (x (combine (select datamat (iseq nobs) (select 
                                                 (send model2 :iv) 0))))
         (otherxs (select datamat (iseq nobs) (remove 
                                  (select (send model2 :iv) 0)
                                          (send model2 :iv)))) 
         (y (combine (select datamat (iseq nobs) (send model2 :dv))))
         (yx-mod (regression-model otherxs y :print nil))
         (xx-mod (regression-model otherxs x :print nil))
         (rsqp (rsq-plot self :variable-labels '("Iterations"
                                            "R-Square/Betas")
                              :title "R-Square/Betas"
                              :go-away t
                              :show nil))
         (rp1 (residual-plot self (send model :fit-values)
                            (send model :raw-residuals)
                            :go-away t
                            :show nil :title "Residuals 1"
                            ))
         (ip1 (influence-plot self (send model :fit-values)
                            (send model :cooks-distances)
                            :title "Influence 1"
                            :go-away t
                            :show nil))
         (tp1 nil)
         (rp2 (residual-plot self (send model :fit-values)
                            (send model :raw-residuals)
                            :show nil
                            :go-away t
                            :title "Residuals 2"))
         (ip2 (influence-plot self (send model :fit-values)
                            (send model :leverages)
                            :title "Influence 2"
                            :go-away t
                            :show nil))
         (lr (lin-reg-plot self (send lin-reg :Y) (send lin-reg :fit-values) 
                         :title "OLS Regression"
                         :go-away t
                         :show nil))
         (var-list (send var-list-proto :new self))
         (obs-list (send obs-list-proto :new self))
         (av (added-var-plot self (send xx-mod :residuals) 
                             (send yx-mod :residuals) :show nil))
         )
    
    (if (= (send model :count) 0)
        (setf tp1 (lsmt-plot (send model :YRaw) (send model :Y)
                             (send model :fit-values) self 
                             :title "LS Monotone Transformation"
                             :show nil))
        (setf tp1 (lsmt-plot (send model :YRaw) (send model :Y)
                             (send model :YHat) self
                             :title "LS Monotone Transformation"
                             :show nil)))
    (send rp1 :variable-label '(0 1) (list pred "OLS Raw Residuals"))
    (send ip1 :variable-label '(0 1) (list pred "OLS Cook's Distances"))
    (send rp2 :variable-label '(0 1) (list pred "OLS Raw Residuals"))
    (send ip2 :variable-label '(0 1) (list pred "OLS Leverages"))
    (send av :variable-label '(0 1) (list (strcat (select (send model2 :variables) 
                             (select (send model2 :iv) 0)) "|Other Vars") 
                             (strcat dv "|Other Vars")))
    (send rp1 :location (select loc12 0) (select loc12 1))
    (send rp1 :abline 0.0 0.0)
    (send rp2 :location (select loc22 0) (select loc22 1))
    (send rp2 :abline 0.0 0.0)
    (send ip1 :location (select loc13 0) (select loc13 1))
    (send ip2 :location (select loc23 0) (select loc23 1))
    (send tp1 :variable-label '(0 1)
          (list dv pred))
    (send tp1 :location (select loc11 0) (select loc11 1))
    (send tp1 :redraw)
    (send tp1 :title "OLS Regression")
    (send lr :abline 0 1)
    (send lr :location (select loc11 0) (select loc11 1))
    (send var-list :location (select loc22 0) (select loc22 1))
    (send obs-list :location (select loc21 0) (select loc21 1))
    (send av :location (select loc22 0) (select loc22 1))
    (send self :residual-plot1 rp1)
    (send self :residual-plot2 rp2)
    (send self :influence-plot1 ip1)
    (send self :influence-plot2 ip2)
    (send self :transformation-plot tp1)
    (send self :lin-reg-plot lr)
    (send self :added-var-plot av)
    (send self :var-list var-list)
    (send self :obs-list obs-list)
    (send self :resid-type1 "LR-Raw")
    (send self :resid-type2 "LR-Bayes")
    (send self :infl-type1 "LR-Cooks")
    (send self :infl-type2 "LR-Lev")
    (send self :update-residual-plot)
    
    (when (> (send model :count) 0)
          (dotimes (k count)
             (setf iteration-list (append iteration-list 
                             (list (repeat k (length (first 
                                             (send model :standardized-beta-list)))))))))
    (send rsqp :clear-points)
    (send rsqp :clear-lines)
    (dotimes (k count)
             (setf iteration-list (append iteration-list 
                             (list (repeat k (length (first 
                                   (send model :standardized-beta-list))))))))
    (dotimes (j (length (first (send model :standardized-beta-list)))) 
           (dotimes (i (length (send model :standardized-beta-list)))  
                    (setf rsq-beta-list (append rsq-beta-list (list 
                                  (select (select 
                                  (send model :standardized-beta-list) i) 
                                          j))))
                    (setf iter-list (append iter-list (list (select (select
                                    iteration-list i) j)))))
           (send rsqp :add-lines iter-list rsq-beta-list)
           (send rsqp :add-lines (iseq count) rsq-list)
           (setf i 0)
           (setf iter-list nil)
           (setf rsq-beta-list nil))
    (send rsqp :add-points (list (repeat (send model :count) 
            (length (combine (last (send model :standardized-beta-list)))))
                    (combine (last (send model :standardized-beta-list))))
            :point-labels (select (send (send self :model) :variables)
                                (send (send self :model) :iv)))
    (when (equalp (send model :count) 0)
          (send rsqp :add-points (list 0) (list (send model :r-squared))))
    (when (> (send model :count) 0)
          (send rsqp :add-points (list (send model :count)) 
                     (list (select (send model :rsq-list) 
                                   (send model :count)))
                     :point-labels (list "RSQ")))


    (send rsqp :location (select loc23 0) (select loc23 1))
    (send self :rsq-beta-plot rsqp)    
    (mapcar #'(lambda (x) (send x :size (+ plot-size window-decoration-width) 
                                plot-size)
                          (send x :linked t)
                          (send x :adjust-to-data)) (send self :all-plots))
    (setf plots (remove (send self :var-list) (send self :all-plots)))
    (setf plots (remove (send self :obs-list) plots))
    (mapcar #'(lambda (x) (send x :add-overlay (make-overlay2 x self))
              ) plots)
    (mapcar #'(lambda (x) (send x :showing t))
            (list tp1 rp1 ip1 obs-list av ip2))
    ))