;;########################################################################
;; vismenu2.lsp
;; contains code to define ViSta command and file menus
;; Copyright (c) 1991-96 by Forrest W. Young
;; X11 changes by Anthony J. Rossini
;;########################################################################
(defun quit ())

(defun save-exit ()
"Changes Quit or Exit to present warning dialog box"
  (let (
#+macintosh (exit-item (- (length (send *file-menu* :items)) 1))
#+msdos     (exit-item  3)
#+X11       (exit-item  10)
        )
    (send *file-menu* :delete-items
          (select (send *file-menu* :items) exit-item))
    (send *file-menu* :append-items
          (send menu-item-proto :new "Quit" :key #\Q 
                :action #'(lambda () (quit) )
                ))))
;save-exit-dialog-box function is in function.lsp

;; AJR add msdos, X11.
;;#-macintosh (defvar *command-menu* (send menu-proto :new "Command"))
#+msdos (defvar *command-menu* (send menu-proto :new "Command"))
#+X11   (defvar *command-menu* (send menu-proto :new "Command"))

(setf command-menu-dribble-item
      (send menu-item-proto :new "Dribble"
            :action #'(lambda ()
            (cond
              ((send command-menu-dribble-item :mark) (dribble)
               (send command-menu-dribble-item :mark nil))
              (t (let ((f 

#-X11  (set-file-dialog "Dribble file:")
#+X11  (file-save-dialog "Dribble file:" "*.txt" "." "dribble.txt")

))
                   (when f
                         (dribble f)
                         (send command-menu-dribble-item :mark t))))))))

;;RAF 7/28/95
(setf command-menu-workmap-item
   ;;   (send menu-item-proto :new "Show WorkMap" :key #\W
   ;;         :action #'(lambda () (send *workmap* :gui t)))
      (send menu-item-proto :new "Show WorkMap"
            :action #'(lambda () (send *workmap* :gui t))))

;;RAF 7/28/95
(setf command-menu-guidemap-item
    ;;  (send menu-item-proto :new "Show GuideMap" :key #\G
    ;;        :action 'show-guidemap)
      (send menu-item-proto :new "Show GuideMap"
            :action 'show-guidemap))

(setf command-menu-show-tool-item
      (send menu-item-proto :new "Show ToolBar" :key #\T
            :action 'show-toolbar))

(setf command-menu-hide-tool-item
      (send menu-item-proto :new "Hide ToolBar" :key #\T
            :action 'hide-toolbar))

(setf command-menu-preferences-item
      (send menu-item-proto :new "Preferences ... "
            :action #'(lambda () (send *vista* :preferences))))

(setf command-menu-buglist-item
      (send menu-item-proto :new "Show Bug List"
            :action 'show-bug-list))

(setf command-menu-fonts-item
      (send menu-item-proto :new "Set Fonts"
            :action #'(lambda () (load "config.lsp"))))

(defun select-current-data-icon ()
  (send *workmap* :select-icon
        (select (send *workmap* :data-icon-number-list)
                (- current-item-number
                   (send *workmap* :num-data-menu-items)))))

#+macintosh(setf dash1 (select (send *command-menu* :items) 1))
#+macintosh(setf cleanup (select (send *command-menu* :items) 2))
#+macintosh(setf toplevel (select (send *command-menu* :items) 3))
#+macintosh(setf dash2 (select (send *command-menu* :items) 4))
#+macintosh(setf dribble (select (send *command-menu* :items) 5))
#+macintosh(setf repeat (select (send *command-menu* :items) 6))
#+macintosh(send *command-menu* :delete-items
                 dash1 cleanup toplevel dash2 dribble repeat)

(send *command-menu* :append-items
            command-menu-workmap-item
            command-menu-guidemap-item
            (send dash-item-proto :new)
#-macintosh (send menu-item-proto :new "Clean Up" :action #'clean-up)
#+macintosh cleanup
#-macintosh (send menu-item-proto :new "Toplevel" :action #'top-level)
#+macintosh toplevel
#-macintosh command-menu-dribble-item
#+macintosh dribble
#+macintosh repeat
            (send dash-item-proto :new)
            command-menu-preferences-item
            command-menu-show-tool-item
#+msdos     command-menu-fonts-item
            command-menu-buglist-item)

(setf new-data-file-menu-item
      (send menu-item-proto :new "New Data" :key #\N
            :action 'new-data))

(setf open-data-file-menu-item
      (send menu-item-proto :new "Open Data" :key #\O
            :action 'open-data))

(setf simulate-data-file-menu-item
      (send menu-item-proto :new "Simulate Data"
            :action 'simulate-data))

(setf import-data-file-menu-item
      (send menu-item-proto :new "Import Data"
            :action 'import-data))


;;RAF 7/29/95
#+macintosh (setf close-window-menu-item
                  (send menu-item-proto :new "Close Window" :key  #\W
                        :action
                        #'(lambda ()
                            (let* (
                                   (fw (front-window))
                                   )
                              (if (send fw :has-method ':close)
                                  (send fw :close)) )) ))

;;RAF 7/29/95
#+macintosh (defmeth close-window-menu-item :update ()
              (let (
                    (fw (front-window))
                    )
                (if fw
                    (send self :enabled (send fw :has-method ':close))
                    (send self :enabled nil) )) )

#+macintosh (defun close-window ()
              (send close-window-menu-item :do-action))

(defun mac-file-menu ()
  (let ((file-menu-items (send *file-menu* :items))
        )
    (apply #'send *file-menu* ':delete-items file-menu-items)
    (send *file-menu* :append-items
          new-data-file-menu-item    ;new data 0
          open-data-file-menu-item   ;open data 1
          simulate-data-file-menu-item
          import-data-file-menu-item
          (send dash-item-proto :new)
          (select file-menu-items 2) ;new edit   5
          (select file-menu-items 3) ;open edit  6
          (select file-menu-items 4) ;dash 7
          (select file-menu-items 5) ;save edit 8
          (select file-menu-items 6) ;save edit as 9
          (select file-menu-items 7) ;save edit copy 10
          (select file-menu-items 8) ;revert 11
          (select file-menu-items 9) ;dash 12
          (select file-menu-items 0) ;load edit 13
          load-data-menu-item
          load-model-menu-item
          (send dash-item-proto :new)
          close-window-menu-item
          (select file-menu-items 10);quit
          )
    (send (select (send *file-menu* :items) 13) :title "Load Edit")
    (send (select (send *file-menu* :items) 5)  :key nil)
    (send (select (send *file-menu* :items) 6) :key nil)
     ))
#+macintosh(mac-file-menu)

(defun msdos-file-menu ()
  (apply #'send *file-menu* ':delete-items (send *file-menu* :items))
  (send *file-menu* :append-items
        new-data-file-menu-item
        open-data-file-menu-item
        load-data-menu-item
        (send dash-item-proto :new)
        simulate-data-file-menu-item
        import-data-file-menu-item
        (send dash-item-proto :new)
        load-model-menu-item
        (send menu-item-proto :new "&Load Edit" :action
              #'(lambda ()
                  (let ((fname (open-file-dialog)))
                    (if fname (load fname)))))
        (send dash-item-proto :new)
        
        (send menu-item-proto :new "About XLISP-STAT ..." :action #'about-xlisp-stat)
        (send menu-item-proto :new "About ViSta ..." :action #'about-vista)
        (send dash-item-proto :new)	
        (send menu-item-proto :new "E&xit" :action #'quit)
        )
  (send *file-menu* :install))

;(defun msdos-file-menu () (mac-file-menu))
#+msdos(msdos-file-menu)


;; AJR -- needed for X11.
(defun x11-file-menu ()
  (apply #'send *file-menu* ':delete-items (send *file-menu* :items))
  (send *file-menu* :append-items
        new-data-file-menu-item
        open-data-file-menu-item
        load-data-menu-item
        (send dash-item-proto :new)
        simulate-data-file-menu-item
        import-data-file-menu-item
        (send dash-item-proto :new)
        load-model-menu-item
        (send menu-item-proto :new "Load Edit" :action
              #'(lambda ()
                  (let ((fname (open-file-dialog)))
                    (if fname (load fname)))))
        (send dash-item-proto :new)
        (send menu-item-proto :new "Quit" :action #'quit)
        (send menu-item-proto :new "About XLISP-STAT ..." :action #'about-xlisp-stat)
        (send menu-item-proto :new "About ViSta ..." :action #'about-vista))
  (send *file-menu* :install))
#+X11 (x11-file-menu)


;;RAF 7/29/95
#+macintosh(send (select (send *edit-menu* :items) 10) :key #\G)
#+macintosh(send *edit-menu* :append-items
                 (send dash-item-proto :new)
                 (send menu-item-proto :new "Read Clipboard" 
                       :action #'(lambda () (read-clipboard))))
#+macintosh(defun remove-undo-item ()
             (let* ((edit-menu-items (send *edit-menu* :items))
                    (edit-menu-length (1- (length edit-menu-items)))
                    (edit-items (select edit-menu-items 
                                        (iseq 2 edit-menu-length)))
                    )
               (apply #'send *edit-menu* :delete-items edit-menu-items)
               (apply #'send *edit-menu* :append-items edit-items)))
#+macintosh(remove-undo-item)

; asked charlie to remove #-X11 on next stmnt. Will quit work under X11?
#-X11(save-exit) 

(defvar *expert-menu* (send menu-proto :new "Tools"))

(setf link-icon-expert-menu-item
      (send menu-item-proto :new "Auto LINK Icon" :enabled t
            :action 'auto-link-icon))

(setf return-icon-expert-menu-item
      (send menu-item-proto :new "Auto RETURN Icon" :enabled t
            :action 'auto-return-icon))

(setf link-button-expert-menu-item
      (send menu-item-proto :new "LINK Button" :enabled t
            :action 'link-button))

(setf return-button-expert-menu-item
      (send menu-item-proto :new "RETURN Button" :enabled t
            :action 'return-button))

(setf goto-button-expert-menu-item
      (send menu-item-proto :new "GOTO Button" :enabled t
            :action 'goto-button))

(setf and-icon-expert-menu-item
      (send menu-item-proto :new "AND Icon" :enabled t
            :action 'and-icon))

(setf connect-icons-expert-menu-item
      (send menu-item-proto :new "Connect Objects" :enabled t
            :action 'connect-objects))

(setf active-icon-expert-menu-item
      (send menu-item-proto :new "Initial Button" :enabled t
            :action #'(lambda () (send *expertmap* :initial-button))))

(setf save-expert-menu-item
      (send menu-item-proto :new "Save Author Map" :enabled t
            :action #'(lambda () (send *expertmap* :save-workmap))))

(send *expert-menu* :append-items
      and-icon-expert-menu-item
      link-icon-expert-menu-item
      return-icon-expert-menu-item
      (send dash-item-proto :new)
      link-button-expert-menu-item
      return-button-expert-menu-item
      goto-button-expert-menu-item
      (send dash-item-proto :new)
      connect-icons-expert-menu-item
      active-icon-expert-menu-item
      (send dash-item-proto :new)
      save-expert-menu-item)

(provide "vismenu2")