;;########################################################################
;; ViSta - The Visual Statistics System
;; Copyright (c) 1991-97 by Forrest W. Young
;; Version 4.27 Beta, March 14th, 1997 
;; For further information contact the author at forrest@unc.edu
;; This file contains initialization code
;;########################################################################
;;ViSta runs under the Lisp-Stat statistical computing environment.
;;This is the file to load ViSta once Lisp-Stat is running.  
;;ViSta works on Macintosh microcomputers (68040 & PowerPC), 
;;IBM compatibles with Windows 3.1, 95, or NT, or with OS/2, 
;;and on Unix machines under X11. 
;;########################################################################

(defun strcat (&rest args) (apply #'concatenate 'string args))

(let* ((separator
        #+macintosh ":"
        #+msdos "\\"
        #+X11 "/"
        )
       ;; CHANGE: For Unix, the following line must be the home location of
       ;; Vista, i.e. it should be $YourDir/vista
       #+X11(working-directory "/afs/cs.unc.edu/home/kurak/CK/vista4.27")
       #-X11(working-directory (get-working-directory))
       #+msdos (working-directory (strcat working-directory separator))
       #+X11 (working-directory (strcat working-directory separator));;AJR
       ) 
  ;;(setf *startup-dir* (get-working-directory))
  (setf *startup-dir* working-directory)
  (setf *vista-dir-name* (strcat *startup-dir* "code" separator))
  (setf *data-dir-name*  (strcat *startup-dir* "data" separator))
  (setf *code-dir-name*  (strcat *startup-dir* "code" separator))
  (setf *help-dir-name*    
        (strcat *startup-dir* "code" separator "help" separator))
  (setf *guide-dir-name*   
        (strcat *startup-dir* "code" separator "guidance" separator))
  (setf *example-dir-name* (strcat *startup-dir* "example" separator)))

(setf config-vistaxls nil)

(load (strcat *vista-dir-name* "prefload"))

#+msdos (when config-vistaxls 
              (let ((oldbreak *breakenable*)
                    (f (open (strcat *vista-dir-name* 
                                     "prefload.lsp") 
                             :direction :output)))
                (setq *breakenable* nil)
                (unwind-protect
                 (princ `(setf ask-load-vista ,ask-load-vista) f)
                 (princ "(setf memory-message nil)" f))
                (setq *breakenable* oldbreak)
                (close f))
              (load "config"))

#+macintosh(defun repeat-command ()
"Repeats previous command.  Written by Frederic Udina."
  (send *listener* :paste-string (string-downcase (format nil "~s" -)))
  (send *listener* :show-window))

#+macintosh(defun add-repeat-to-menu ()
; Next statement prevents error if calling the repeat function before
; - is defined by the first read
  (setq - nil)
  (send *command-menu*
        :append-items
        (send menu-item-proto
              :new "Repeat Command"
              :action 'repeat-command
              :key #\')))

#+macintosh(add-repeat-to-menu)

(defun load-vista ()
  (let ((yesno t)
        )
    (when ask-load-vista
          (setf yesno (ok-or-cancel-dialog (format nil "XLisp-Stat has been loaded.~%Proceed to Load ViSta as well?"))))
    (when yesno
          (expand 85)
          (when (not (load (strcat *vista-dir-name* "vista")
                           :if-does-not-exist nil))
                (message-dialog 
                 (format nil "ERROR: ViSta was not found.
~%It was sought in directory: ~%~a~%You must restructure your files~%so that ViSta is in that directory." *vista-dir-name*) t)))))

(provide "statinit")
(when (not config-vistaxls) (load-vista))
